package com.casic.dcms.vm;

import androidx.lifecycle.MutableLiveData;

import com.casic.dcms.base.BaseApplication;
import com.casic.dcms.model.ActionResultBean;
import com.casic.dcms.model.AlarmDataBean;
import com.casic.dcms.utils.StringHelper;
import com.casic.dcms.utils.retrofit.RetrofitServiceManager;
import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;
import com.pengxh.androidx.lite.callback.OnObserverCallback;
import com.pengxh.androidx.lite.hub.StringHub;
import com.pengxh.androidx.lite.vm.BaseViewModel;
import com.pengxh.androidx.lite.vm.LoadState;
import com.pengxh.androidx.lite.vm.ObserverSubscriber;

import java.io.IOException;
import java.net.ConnectException;

import okhttp3.ResponseBody;
import rx.Observable;

public class AlarmViewModel extends BaseViewModel {
    private final Gson gson = new Gson();
    public MutableLiveData<AlarmDataBean> resultModel = new MutableLiveData<>();
    public MutableLiveData<ActionResultBean> cancelActionModel = new MutableLiveData<>();

    public void obtainAlarmList(int limit, int offset) {
        loadState.setValue(LoadState.Loading);
        Observable<ResponseBody> alarmListObservable = RetrofitServiceManager.getAlarmListResult(limit, offset);
        ObserverSubscriber.addSubscribe(alarmListObservable, new OnObserverCallback() {
            @Override
            public void onCompleted() {
                loadState.setValue(LoadState.Success);
            }

            @Override
            public void onError(Throwable e) {
                loadState.setValue(LoadState.Fail);
                if (e instanceof ConnectException) {
                    StringHub.show(BaseApplication.get(), "连接失败，请检查网络或者服务器");
                } else {
                    StringHub.show(BaseApplication.get(), "服务器异常，请联系管理员");
                }
            }

            @Override
            public void onNext(ResponseBody responseBody) {
                try {
                    String response = responseBody.string();
                    int responseCode = StringHelper.separateResponseCode(response);
                    if (responseCode == 200) {
                        AlarmDataBean alarmDataBean = gson.fromJson(response, new TypeToken<AlarmDataBean>() {
                        }.getType());
                        resultModel.setValue(alarmDataBean);
                    } else {
                        loadState.setValue(LoadState.Fail);
                        StringHelper.showErrorMessage(response);
                    }
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        });
    }

    public void cancelSingleAlarm(String id, String jobStatus, String handleMessage) {
        loadState.setValue(LoadState.Loading);
        Observable<ResponseBody> commonActionObservable = RetrofitServiceManager.getCancelAlarmResult(id, jobStatus, handleMessage);
        ObserverSubscriber.addSubscribe(commonActionObservable, new OnObserverCallback() {
            @Override
            public void onCompleted() {
                loadState.setValue(LoadState.Success);
            }

            @Override
            public void onError(Throwable e) {
                loadState.setValue(LoadState.Fail);
                if (e instanceof ConnectException) {
                    StringHub.show(BaseApplication.get(), "连接失败，请检查网络或者服务器");
                } else {
                    StringHub.show(BaseApplication.get(), "服务器异常，请联系管理员");
                }
            }

            @Override
            public void onNext(ResponseBody responseBody) {
                try {
                    String response = responseBody.string();
                    int responseCode = StringHelper.separateResponseCode(response);
                    if (responseCode == 200) {
                        ActionResultBean resultBean = gson.fromJson(response, new TypeToken<ActionResultBean>() {
                        }.getType());
                        cancelActionModel.setValue(resultBean);
                    } else {
                        loadState.setValue(LoadState.Fail);
                        StringHelper.showErrorMessage(response);
                    }
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        });
    }

    public void cancelBatchAlarm(String jobStatus, String handleMessage) {
        loadState.setValue(LoadState.Loading);
        Observable<ResponseBody> commonActionObservable = RetrofitServiceManager.getCancelAlarmResult(jobStatus, handleMessage);
        ObserverSubscriber.addSubscribe(commonActionObservable, new OnObserverCallback() {
            @Override
            public void onCompleted() {
                loadState.setValue(LoadState.Success);
            }

            @Override
            public void onError(Throwable e) {
                loadState.setValue(LoadState.Fail);
                if (e instanceof ConnectException) {
                    StringHub.show(BaseApplication.get(), "连接失败，请检查网络或者服务器");
                } else {
                    StringHub.show(BaseApplication.get(), "服务器异常，请联系管理员");
                }
            }

            @Override
            public void onNext(ResponseBody responseBody) {
                try {
                    String response = responseBody.string();
                    int responseCode = StringHelper.separateResponseCode(response);
                    if (responseCode == 200) {
                        ActionResultBean resultBean = gson.fromJson(response, new TypeToken<ActionResultBean>() {
                        }.getType());
                        cancelActionModel.setValue(resultBean);
                    } else {
                        loadState.setValue(LoadState.Fail);
                        StringHelper.showErrorMessage(response);
                    }
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        });
    }
}
